package org.apache.bcel.classfile;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.io.DataInput;
import java.io.IOException;
import org.apache.bcel.classfile.Attribute;
import org.apache.bcel.classfile.ClassFormatException;
import org.apache.bcel.classfile.ConstantPool;
import org.apache.bcel.classfile.ConstantValue;
import org.apache.bcel.classfile.FieldOrMethod;
import org.apache.bcel.classfile.Utility;
import org.apache.bcel.classfile.Visitor;
import org.apache.bcel.generic.Type;
import org.apache.bcel.util.BCELComparator;

public final class Field extends FieldOrMethod {
  public static final org.apache.bcel.classfile.Field[] EMPTY_ARRAY = new org.apache.bcel.classfile.Field[0];
  
  private static BCELComparator bcelComparator = (BCELComparator)new Object();
  
  static final org.apache.bcel.classfile.Field[] EMPTY_FIELD_ARRAY = new org.apache.bcel.classfile.Field[0];
  
  public static BCELComparator getComparator() {
    return bcelComparator;
  }
  
  public static void setComparator(BCELComparator comparator) {
    bcelComparator = comparator;
  }
  
  Field(DataInput file, ConstantPool constantPool) throws IOException, ClassFormatException {
    super(file, constantPool);
  }
  
  public Field(org.apache.bcel.classfile.Field c) {
    super(c);
  }
  
  public Field(int accessFlags, int nameIndex, int signatureIndex, Attribute[] attributes, ConstantPool constantPool) {
    super(accessFlags, nameIndex, signatureIndex, attributes, constantPool);
  }
  
  public void accept(Visitor v) {
    v.visitField(this);
  }
  
  public org.apache.bcel.classfile.Field copy(ConstantPool constantPool) {
    return (org.apache.bcel.classfile.Field)copy_(constantPool);
  }
  
  public boolean equals(Object obj) {
    return bcelComparator.equals(this, obj);
  }
  
  public ConstantValue getConstantValue() {
    for (Attribute attribute : getAttributes()) {
      if (attribute.getTag() == 1)
        return (ConstantValue)attribute; 
    } 
    return null;
  }
  
  public Type getType() {
    return Type.getReturnType(getSignature());
  }
  
  public int hashCode() {
    return bcelComparator.hashCode(this);
  }
  
  public String toString() {
    String access = Utility.accessToString(getAccessFlags());
    access = access.isEmpty() ? "" : (access + " ");
    String signature = Utility.signatureToString(getSignature());
    String name = getName();
    StringBuilder buf = new StringBuilder(64);
    buf.append(access).append(signature).append(" ").append(name);
    ConstantValue cv = getConstantValue();
    if (cv != null)
      buf.append(" = ").append(cv); 
    for (Attribute attribute : getAttributes()) {
      if (!(attribute instanceof ConstantValue))
        buf.append(" [").append(attribute).append("]"); 
    } 
    return buf.toString();
  }
}
